/*  UNDEAD TERROR
 *  armes.h
 *  
 *
 *  Created by FlavR & Leo.
 *  Copyright 2010. All rights reserved.
 *
 */

#ifndef __ARMES__
#define __ARMES__

//Bullets structure
typedef struct 
{
	float x, y;
	float avX, avY;
	float angle;
	int isVisible;
} Balle;


//Weapon structure
typedef struct
{
	char* name;
	int magazineCapacity;
	int magazineUsedContent;
	int type; //1: semi-auto; 2: auto
	int reloadTime, reloadSleep;
	int damage;
	int L, a; //Better bullet positionning
	float t;
	
	ge_Image *img;
} Weapon;


//Creates a bullet
Balle creerTir(float angle, int L, int a, int EPAULE_X, int EPAULE_Y);

//Loads a weapon
Weapon initWeapon(char* name, char *image, int capacity, int type, int reloadTime, int damage, int L, int a, float t);

//Chages a weapon
int ChangeWeapon(int);

//Free a weapon
void freeWeapon(Weapon w);

#endif

//EOF
