/*  UNDEAD TERROR
 *  function.h
 *  
 *
 *  Created by FlavR & Leo.
 *  Copyright 2010. All rights reserved.
 *
 */

#ifndef __FUNCTIONS__
#define __FUNCTIONS__

/* Defines */
#define MaxActivesZombies 10 //Max of zombiez that can be shown on the screen.
#define NB_NIVEAUX 10 //Number of levels

ge_Image *Back[NB_NIVEAUX];
ge_Image *Cache[NB_NIVEAUX];


//Units conversion
float rad2deg(float angle);
float deg2rad(float angle);

//Getting an angle from 2 point
float getAngle(float x, float y, float x0, float y0);

 //Delete the '\n'
void supprRC(char* ligne);

//Fast fprintf function(useful for debug)
void DoLog(const char *msg, const char *path);

//Faster char/sprintf
char *strPrint(const char *format, ...);

//Printf Magazine (in the bottom of the sceen in game)
void printMagazine(int x, int y, int total, int actual, ge_Image* Img, bool reload);

//Checks if object is out of screen
bool isOutOfScreen(float x, float y, float l, float h);

//Check if collision has happened.
bool doesCollisionHappend(float x1, float y1, float l1, float h1,float x2, float y2, float l2, float h2);

//Qte function
bool QTE(ge_Image* imgTouches);

//Show the loading animation
void printLoading(ge_Image *loadingImage, int num);

//Read the current level from Niveaux/Level 
int readNewLevel();

//Writes the level
void writeLevel(int level);

#endif

//EOF
