/*  UNDEAD TERROR
 *  gui.c
 *  
 *
 *  Created by FlavR & Leo.
 *  Copyright 2010. All rights reserved.
 *
 */

#include <libge/libge.h>
#include <stdlib.h>
#include <ctype.h>

#include "functions.h"
#include "gui.h"

void geIntraFontPrintScreenBordered(int x, int y, ge_Font *police, const char *texte, u32 colorText, u32 colorContour) //Function by JiiCeii ;-)
{
    geIntraFontPrintScreen(x-1, y, police, texte, colorContour);
    geIntraFontPrintScreen(x+1, y, police, texte, colorContour);
    geIntraFontPrintScreen(x-1, y-1, police, texte, colorContour);
    geIntraFontPrintScreen(x-1, y+1, police, texte, colorContour);
    geIntraFontPrintScreen(x, y+1, police, texte, colorContour);
    geIntraFontPrintScreen(x, y-1, police, texte, colorContour);
    geIntraFontPrintScreen(x+1, y+1, police, texte, colorContour);
    geIntraFontPrintScreen(x+1, y-1, police, texte, colorContour);
	
	asm("sync\n");
    geIntraFontPrintScreen(x, y, police, texte, colorText);
}

void transition()
{
	int i;
	asm("sync\n");
	for (i= 0; i < 240; i++)
	{
		geFillRectScreen(0,0, i, 272, RGB(0,0,0));
		geFillRectScreen(480-i,0, i, 272, RGB(0,0,0));
		geFillRectScreen(i,0, 480-i, i, RGB(0,0,0));
		geFillRectScreen(i,272-i, 480-i, i, RGB(0,0,0));
		//sceDisplayWaitVblankStart();
		//asm("sync\n");
		geSwapBuffers();
		sceKernelDelayThread(500);
	}
	asm("sync\n");
}
void KeyBoard( char * chaineY, ge_Image * ImgFond,ge_Image * ImgchaineY,ge_Image * ImgClavier, char * Desc, ge_Font* Police )
{
	SceCtrlData pad;//Variables pour les touches
	SceCtrlData oldpad;
	sceCtrlReadBufferPositive(&oldpad, 1);//On remplie une fois le oldpad, pour pouvoir faire les premieres comparaisons
	geFontSize(Police, 18);
	strcpy(chaineY,"");//On vide la chaine
	//Code pour le clavier
	char clavier[6][13][2]=
	{
		{"~","!","@","#","$","%","^","&","*","(",")","_","+"},
		{"`","1","2","3","4","5","6","7","8","9","0","-","="},
		{"q","w","e","r","t","y","u","i","o","p","[","]","|"},
		{"a","s","d","f","g","h","j","k","l",";","'","{","}"},
		{"z","x","c","v","b","n","m",",",".","/","<",">","?"},
		{":"," "," "," "," "," "," "," "," "," "," "," "," "}//Vous pouvez remplir les blancs avec d'autres caracteres
	};
	int i, j;
	bool upper = false;
	int x=0;
	int y=0;
	while (1)
	{
		//----Calculs----
		sceCtrlReadBufferPositive(&pad, 1);
		if((pad.Buttons & PSP_CTRL_UP) && !(oldpad.Buttons & PSP_CTRL_UP) && (y > 0))
			{y--;}
		else if((pad.Buttons & PSP_CTRL_DOWN) && !(oldpad.Buttons & PSP_CTRL_DOWN) && (y < 5))
			{y++;}
		else if((pad.Buttons & PSP_CTRL_LEFT) && !(oldpad.Buttons & PSP_CTRL_LEFT) && (x > 0))
			{x--;}
		else if((pad.Buttons & PSP_CTRL_RIGHT) && !(oldpad.Buttons & PSP_CTRL_RIGHT) && (x < 12))
			{x++;}
		if ((pad.Buttons & PSP_CTRL_CROSS) && !(oldpad.Buttons & PSP_CTRL_CROSS))
		{
			strcat(chaineY,clavier[y][x]);
		}
		if ((pad.Buttons & PSP_CTRL_LTRIGGER))
		{
			upper = true;
		}
		if ((pad.Buttons & PSP_CTRL_TRIANGLE) && !(oldpad.Buttons & PSP_CTRL_TRIANGLE))
		{
			strcat(chaineY," ");//Espace
		}
		else if ((pad.Buttons & PSP_CTRL_START) && !(oldpad.Buttons & PSP_CTRL_START))//simulation de la touche ENTER lorsqu'on appuie sur START
		{
			break;
		}
		else if ((pad.Buttons & PSP_CTRL_SQUARE) && !(oldpad.Buttons & PSP_CTRL_SQUARE))//simulation de la touche DEL lorsqu'on appuie sur []
		{
			chaineY[strlen(chaineY) - 1] = 0;
		}
		//----Affichage----
		
		geBlitImage( 0, 0, ImgFond, 0, 0, ImgFond->width, ImgFond->height, 1);
		for ( i = 0; i < 6 ; i++)
		{
			for ( j = 0; j < 13; j++)
			{
				geBlitImage(j*30+20,i*30+20, ImgClavier, 0, 0, ImgClavier->width, ImgClavier->height, 1);
				if (upper && isalpha(clavier[i][j]))
					geIntraFontPrintScreen(j*30+26, i*30+25, Police, strPrint("%i", toupper(clavier[i][j][1])), RGB(0,0,0));
				else
					geIntraFontPrintScreen(j*30+26, i*30+25, Police, clavier[i][j], RGB(0,0,0));
			}
			
		}
		geBlitImageNegative(x*30+20,y*30+20, ImgClavier, 0, 0, ImgClavier->width, ImgClavier->height);
		geIntraFontPrintScreen(x*30+26, y*30+25, Police, clavier[y][x], RGB(255,255,255));
		geIntraFontPrintScreen(1, 1, Police, Desc, RGB(0,0,0));
		geBlitImage(2, 200, ImgchaineY, 0, 0, ImgchaineY->width, ImgchaineY->height,1);
		geIntraFontPrintScreen(12, 205, Police, chaineY, RGB(0,0,0));
		oldpad = pad;
		geSwapBuffers();
	}
	geIntraFontSize(Police, 13);
	return;
}


int makeMenu(ge_Image *back, ge_Font *font, int num, ...)
{	
	va_list arguments; 
	va_start(arguments, num);
	
	char *menu[num];
	
	int i, done = 0, choix = 0;
	
	for (i = 0; i < num; i++)
		menu[i] = va_arg(arguments, char*);
	
	va_end(arguments);
	
	int maxlen = 0;
	
	for (i = 0; i < num; i++)
	{
	if (strlen(menu[i]) > maxlen)
		maxlen = strlen(menu[i]);
	}
	
	SceCtrlData pad, oldpad;
	sceCtrlReadBufferPositive(&oldpad, 1);
	
	sceKernelDelayThread(200 * 1000);
	
	int y = 120 - (num / 2) * 30;
	
	asm("sync\n");
	while (!done)
	{
		sceCtrlReadBufferPositive(&pad, 1);
		
		if (back != NULL)
			geDrawImage(0,0, back);
		else{
			geClearScreen();
			pspDebugScreenSetXY(10,10);
			pspDebugScreenPrintf("Error");}
		
		for (i = 0; i < num; i++)
			geIntraFontPrintScreenBordered(240 - geFontTextWidth(font, menu[i]) / 2, y + (i * 30), font, menu[i], i == choix ? RGB(255,20,10) : RGB(150,150,150), RGBA(255,255,255, 200));
		
		if ((pad.Buttons &PSP_CTRL_DOWN) && !(oldpad.Buttons &PSP_CTRL_DOWN))
			choix = choix < num - 1 ? choix + 1 : 0;
		
		if ((pad.Buttons &PSP_CTRL_UP) && !(oldpad.Buttons &PSP_CTRL_UP))
			choix = choix > 0 ? choix - 1 : num-1;
			
		if ((pad.Buttons &PSP_CTRL_CROSS) && !(oldpad.Buttons &PSP_CTRL_CROSS)) return choix + 1;
		
		oldpad = pad;
		sceDisplayWaitVblankStart();
		//sceKernelDelayThread(10);
		asm("sync\n");
		geSwapBuffers();
		sceDisplayWaitVblankStartCB();
	}
	
	asm("sync\n");

	return 0;
}

void geIntraFontPrintScreenCentered(int y, ge_Font *font, char *text, Color color)
{
	geIntraFontPrintScreen(240 - geFontTextWidth(font, text) / 2, y, font, text, color);	
}

void Lost(ge_Font * font, ge_Image *image, int score)
{
	//geClearColor(RGB(183,0,0));
	SceCtrlData pad, oldpad;
	
	sceCtrlReadBufferPositive(&oldpad, 1);
	
	int av = 0;
	
	char scorePrint[26];
	sprintf(scorePrint, "Your score: %i", score);
	
	while (1)
	{
		//geClearScreen();
		sceCtrlReadBufferPositive(&pad, 1);
		
		geDrawImage(0,0, image);
		
		geBlitImage(0,0, lostBlood, 0, 372 - av, 480, av, true);
		av += av >= 372 ? 0 : 1;
		
		if ((pad.Buttons &PSP_CTRL_CIRCLE) && !(oldpad.Buttons &PSP_CTRL_CIRCLE))
			break;
		
		geIntraFontSize(font, 20);
		geIntraFontPrintScreenCentered(120, font, "You lose!", RGB(255,255,255));
		
		geIntraFontSize(font, 13);
		geIntraFontPrintScreen(475 - geFontTextWidth(font, "O: Back"), 267 - geFontTextHeight(font, "O: Back"), font, "O: Back", RGB(255,255,255));
		geIntraFontPrintScreen(5, 267 - geFontTextHeight(font, scorePrint), font, scorePrint, RGB(255,255,255));
		
		sceKernelDelayThread(10); 
		sceDisplayWaitVblankStart();
		geSwapBuffers();
		oldpad = pad;
	}
	
	//geClearColor(RGB(40,40,40));
	geIntraFontSize(font, 13);
}




//EOF
