#include <libge/libge.h>
#include <stdlib.h>

#include "gui.h"
#include "functions.h"
#include "danzeff.h"

#include "scores.h"

void GetHighScore(scoreS *highScores)
{
	FILE *scoreFile = fopen("Survival/Scores.txt", "r");
	
	char scoreChar[10];
	int i;
	
	if (scoreFile != NULL)
	{
		for (i = 0; i < 10; i++)
		{
			if (fgets(scoreChar, 10, scoreFile) != NULL)
			{
				//supprRC(scoreChar);
				highScores[i].score = atoi(scoreChar);
				DoLog(scoreChar, "log.txt");
			}
			//scoreChar = NULL;
			if (fgets(scoreChar, 20, scoreFile) != NULL)
			{
				char *p = strrchr(scoreChar, '\n');
				if (p != NULL)
				{
					*p = 0;
				}
				strncpy(highScores[i].pseudo, scoreChar,20);
				DoLog(scoreChar, "log.txt");
			}
		}
		fclose(scoreFile);
	}
	else DoLog("Error reading Survival High Scores", "log.txt");
	
	//return highScores;
}
scoreS newHighScore(int Score, ge_Font* font, ge_Image*bg)
{
	/*ge_Image *ImgFond = geCreateSurface(480, 272, RGB(255, 255, 355));//On charge l'image de ImgFond
	ge_Image * ImgClavier = geLoadImage("Images/touche.png");
	ge_Image * ImgchaineY = geLoadImage("Images/zonetext.jpg");*/
	char Desc[100] = "New Highscore! Enter your name:";//Description pour le clavier
	scoreS temp;
	
	temp.score = Score;
	/*KeyBoard( &*temp.pseudo, ImgFond,ImgchaineY,ImgClavier, Desc, font);//On lance le clavier*/
	strcpy(temp.pseudo, startDanzeff(font,"", Desc, bg));//On lance le clavier
	
	// ImgFond = NULL;
	// ImgClavier = NULL;
	// ImgchaineY = NULL;
	
	sprintf(Desc,"%i",temp.score);
	
	DoLog(Desc, "log.txt");
	DoLog(temp.pseudo, "log.txt");
	
	return temp;
}
void ListHighScore(scoreS*highScores)
{
	int i = 9;
	int index, temp;
	char tempP[20];
			
	while(i > 0)
	{
		index = 0;
		
		while(index < i)
		{
			if(highScores[index].score > highScores[index + 1].score)
			{
				temp = highScores[index + 1].score;
				strcpy(tempP, highScores[index + 1].pseudo);
				highScores[index + 1].score = highScores[index].score;
				strcpy(highScores[index + 1].pseudo, highScores[index].pseudo);
				highScores[index].score = temp;
				strcpy(highScores[index].pseudo, tempP);
			}
			index++;
		}
		
		i--;
	}
}

int WriteHighScore(scoreS*highScores)
{
	FILE *scoreFile = fopen("Survival/Scores.txt", "w");
	int i;
	
	if (scoreFile != NULL)
	{	
		for (i = 0; i < 10; i++)
		{
			fprintf(scoreFile, "%i\n", highScores[i].score);
			fprintf(scoreFile, "%s\n", highScores[i].pseudo);
		}
		
		fclose(scoreFile);
		return 0;
	}
	
	else DoLog("Error writing Suvival High Score", "log.txt");return -1;
}

void PrintHighScore(scoreS*highScores, ge_Font*font, ge_Image*Fond)
{
	int i;
	char Buffer[10];
	SceCtrlData pad;
	asm("sync\n");
	while (1)
	{
		geClearScreen();
		geDrawImage(0,0,Fond);
		sceCtrlReadBufferPositive(&pad, 1);
		for (i=0; i < 10; i++)
		{
			sprintf(Buffer,"%i",highScores[9 - i].score);
			geIntraFontPrintScreenBordered(20, 25 + (i * 20), font, Buffer, RGB(255, 255, 255), RGBA(10,10,10, 200));
			geIntraFontPrintScreenBordered(200, 25 + (i * 20), font, highScores[9 - i].pseudo, RGB(255, 255, 255), RGBA(10,10,10, 200));
		}
		geIntraFontPrintScreen(420 , 257, font, "O: Back", RGB(255,255,255));
		if((pad.Buttons &PSP_CTRL_CROSS)||(pad.Buttons &PSP_CTRL_CIRCLE)) break;
		
		
		//sceDisplayWaitVblankStart();
		//sceKernelDelayThread(10);
		asm("sync\n");
		geSwapBuffers();
	}
	transition();
	asm("sync\n");
}

