/*  UNDEAD TERROR
 *  splash.c
 *  
 *
 *  Created by FlavR & Leo.
 *  Copyright 2010. All rights reserved.
 *
 */

#include <libge/libge.h>

#include "splash.h"

void showSplash()
{	
	ge_Image *splash[3];
	splash[0] = geLoadImage("Splash/psphacks.png");
	splash[1] = geLoadImage("Splash/scenery.png");
	splash[2] = geLoadImage("Splash/neoflash.png");
	
	int current = 0;
	int anim = 0;
	
	ge_Timer *timer = geCreateTimer("timer");
	
	int done = 0;
	
	geStartTimer(timer);
	
	SceCtrlData pad;
	
	while (!done)
	{
		geClearScreen();
		sceCtrlReadBufferPositive(&pad, 1);
		
		geDrawImage(0,0, splash[current]);
		
		if ((timer->ellapsed > 3000000) && (current < 2))
		{
			anim++;
			geBlitImage(0, 0, splash[current + 1], 0, 0, 480, anim, true);
			geBlitImage(0, 272 - anim, splash[current + 1], 0, 272 - anim, 480, anim, true);
			
			if (anim == 136)
			{
				geResetTimer(timer);
				anim = 0;
				current++;
				geStartTimer(timer);
			}
		}
		
		if ((current == 2) && (timer->ellapsed > 3000000))
			done = 1;
		
		if (pad.Buttons &PSP_CTRL_CROSS)
			done = 2;
		
		geSwapBuffers();
		geUpdateTimer(timer);
	}
	
	geFreeImage(splash[0]);
	geFreeImage(splash[1]);
	geFreeImage(splash[2]);
}

//EOF
