/*  UNDEAD TERROR
 *  zombis.c
 *  
 *
 *  Created by FlavR & Leo.
 *  Copyright 2010. All rights reserved.
 *
 */

#include <malloc.h>
#include <libge/libge.h>

#include "zombis.h"

//Create zombis sprites
ImageZombi creerImageZombi(ge_Image *img, int nbSprite, int vie)
{
	ImageZombi temp;
	
	temp.img = img;
	geSwizzle(temp.img);
	
	temp.L = img->width / nbSprite;
	temp.H = img->height;
	temp.nbSprite = nbSprite;
	temp.vie = vie;
	
	return temp;
}

//Free zombis image
void freeImageZombi(ImageZombi i)
{
	free(i.img->data);
	free(i.img);
}
	
//Creates a zombis
Zombi creerZombie(int type, float x, float y, int mov, int vie)
{
	Zombi temp;
	
	temp.vie = vie;
	temp.totalVie = vie;
	temp.x = x;
	temp.y = y;
	temp.frame = 0;
	temp.sleep = 0;
	temp.type = type;
	temp.visible = true;
	temp.movement = mov;
	
	return temp;
}

//EOF

