/*  UNDEAD TERROR
 *  zombis.h
 *  
 *
 *  Created by FlavR & Leo.
 *  Copyright 2010. All rights reserved.
 *
 */

#ifndef __ZOMBIS__
#define __ZOMBIS__

//Zombis structure
typedef struct
{
	int vie;
	bool visible; //1:visible  0:not visible
	float x;
	float y;
	int type;
	int frame, sleep;
	int movement;
	int totalVie;
} Zombi;

//Zombis sprite
typedef struct
{
	ge_Image* img;
	int nbSprite, L, H, vie;
} ImageZombi;

//Create zombis sprite
ImageZombi creerImageZombi(ge_Image *img, int nbSprite, int vie);

//Free zombis image
void freeImageZombi(ImageZombi i);
	
//Creates a zombis
Zombi creerZombie(int type, float x, float y, int mov, int vie);

#endif

//EOF
