/*
 *  credits.h
 *  
 *
 *  Created by FlavR & Leo on 12/08/10.
 *  Copyright 2010. All rights reserved.
 *
 */

void jouerCredits(ge_Font *font, ge_Image *img)
{
	int done = 0, pos = 275, i;
	
	geIntraFontSize(font, 10);
	
	SceCtrlData pad;
	
	char text[10] [80];
	sprintf(text[0], "Game By:");
	sprintf(text[1], "Leo & FlavR");
	sprintf(text[2], "           ");
	sprintf(text[3], "Thanks to:");
	sprintf(text[4], "PSP-Hacks.com for the Homebrew Idol 3");
	sprintf(text[5], "SceneryBeta.com for The Scenery Beta 2010 IHS");
	sprintf(text[6], "NeoFlash.com for the Neo Summer Retro Coding Contest 2010");
	sprintf(text[7], "Xtreamlua.com for its community ;-)");
	sprintf(text[8], "Metal Slug for its sprites");
	sprintf(text[9], "JiiCeii for the blood pic and Bordered Print Function ;-)");
	
	while (!done)
	{
		sceCtrlReadBufferPositive(&pad, 1);
		geClearScreen();
		geDrawImage(0,0,img);
		
		for (i = 0; i < 10; i++)
			geIntraFontPrintScreenCentered(pos + 17 * i, font, text[i], RGB(255,255,255));
		
		pos -= pos > 35 ? 1 : 0;
		
		geIntraFontPrintScreen(475 - geFontTextWidth(font, "O: Back"), 267 - geFontTextHeight(font, "O: Back"), font, "O: Back", RGB(255,255,255));
		
		if (pad.Buttons &PSP_CTRL_CIRCLE)
			done = 1;
		
		sceDisplayWaitVblankStart();
		geSwapBuffers();
	}
	
	geIntraFontSize(font, 13);
}
